// UrlObjView.cpp : implementation of the CUrlObjView class
//

#include "stdafx.h"
#include "UrlObj.h"

#include "UrlObjDoc.h"
#include "UrlObjView.h"

#include "afxpriv.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CUrlObjView

IMPLEMENT_DYNCREATE(CUrlObjView, CFormView)

BEGIN_MESSAGE_MAP(CUrlObjView, CFormView)
	//{{AFX_MSG_MAP(CUrlObjView)
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CFormView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CFormView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CFormView::OnFilePrintPreview)
	ON_MESSAGE(WM_ONSTOPBINDING, OnStopBind)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CUrlObjView construction/destruction

CUrlObjView::CUrlObjView()
	: CFormView(CUrlObjView::IDD)
{
	//{{AFX_DATA_INIT(CUrlObjView)
	m_classid = _T("");
	m_codebase = _T("");
	m_width = 0;
	m_height = 0;
	m_major = 0;
	m_minor = 0;
	//}}AFX_DATA_INIT
	// TODO: add construction code here

}

CUrlObjView::~CUrlObjView()
{
}

void CUrlObjView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CUrlObjView)
	DDX_Text(pDX, IDC_EDIT1, m_classid);
	DDX_Text(pDX, IDC_EDIT2, m_codebase);
	DDX_Text(pDX, IDC_EDIT3, m_width);
	DDX_Text(pDX, IDC_EDIT4, m_height);
	DDX_Text(pDX, IDC_EDIT5, m_major);
	DDX_Text(pDX, IDC_EDIT6, m_minor);
	//}}AFX_DATA_MAP
}

BOOL CUrlObjView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CFormView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CUrlObjView printing

BOOL CUrlObjView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CUrlObjView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CUrlObjView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

void CUrlObjView::OnPrint(CDC* pDC, CPrintInfo*)
{
	// TODO: add code to print the controls
}

/////////////////////////////////////////////////////////////////////////////
// CUrlObjView diagnostics

#ifdef _DEBUG
void CUrlObjView::AssertValid() const
{
	CFormView::AssertValid();
}

void CUrlObjView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CUrlObjDoc* CUrlObjView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CUrlObjDoc)));
	return (CUrlObjDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CUrlObjView message handlers

void CUrlObjView::OnButton1() 
{
	LPCLASSFACTORY pClassFactory;
	HRESULT hr;

	UpdateData();

	CDC* dc = GetDC();
	CRect rc(28, 110, 28 + m_width, 110 + m_height);
	::MapDialogRect(m_hWnd, &rc);
	dc->Rectangle(&rc);
	dc->DrawText("Downloading...", -1, &rc, DT_CENTER | DT_VCENTER | DT_SINGLELINE);
	ReleaseDC(dc);

	hr = OleInitialize(NULL);
	USES_CONVERSION;
	CLSIDFromString(T2OLE(m_classid), &m_clsid);

	m_download = new CDownload(this);
	hr = CreateBindCtx(0, &m_pBindContext);

	// Note that the URL moniker will not request IWindowForBindingUI from clients 
	// unless the bind context BIND_OPTS specify the grfFlags value of BIND_MAYBOTHERUSER. 
	// The bind context BIND_OPTS is set by calling IBindCtx::SetBindOptions
	BIND_OPTS bindopts;
	m_pBindContext->GetBindOptions(&bindopts);
	bindopts.grfFlags |= BIND_MAYBOTHERUSER;
	m_pBindContext->SetBindOptions(&bindopts);

	m_download->ExternalQueryInterface(&IID_IBindStatusCallback, (void **)&m_pBindStatusCallback);
	hr = RegisterBindStatusCallback(m_pBindContext, m_pBindStatusCallback, 0, 0);
	
	hr = CoGetClassObjectFromURL(m_clsid, T2OLE(m_codebase), 
								 m_major, m_minor, 
								 NULL, m_pBindContext, 
								 CLSCTX_INPROC_HANDLER | CLSCTX_INPROC_SERVER,
								 0, IID_IClassFactory, (void **)&pClassFactory);

	switch (hr)
	{
		case S_OK:
			TRACE("S_OK\n");
			PostMessage(WM_ONSTOPBINDING, (WPARAM)pClassFactory);
		break;

		case MK_S_ASYNCHRONOUS:
			TRACE("MK_S_ASYNCHRONOUS\n");
		break;

		case E_NOINTERFACE:
			TRACE("E_NOINTERFACE\n");
			PostMessage(WM_ONSTOPBINDING, (WPARAM)NULL);
		break;

		default:
			PostMessage(WM_ONSTOPBINDING, (WPARAM)NULL);
		break;
	}
}

LRESULT CUrlObjView::OnStopBind(WPARAM wParam, LPARAM lParam)
{
	m_pBindStatusCallback->Release();
	m_pBindContext->Release();
	delete m_download;

	// instantiate the object and then release it
	// (in real life you might actually use the object, be we just want to install it)
//	LPUNKNOWN pUnk;
//	LPCLASSFACTORY pClassFactory = (LPCLASSFACTORY)wParam;
//	pClassFactory->AddRef();

//	HRESULT hr = pClassFactory->CreateInstance(NULL, IID_IUnknown, (void **)&pUnk);

//	if (SUCCEEDED(hr) && pUnk != NULL)
//		pUnk->Release();

//	pClassFactory->Release();

	CRect rc(28, 110, 28 + m_width, 110 + m_height);
	::MapDialogRect(m_hWnd, &rc);
	BOOL bRes = m_control.CreateControl(m_clsid, NULL, WS_VISIBLE | WS_BORDER, rc, this, 0);

	return 0;
}
